## ros-kinetic-wave-gazebo-plugins 1.3.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(wave_gazebo_plugins)

###############################################################################
# Compile as C++11, supported in ROS Kinetic and newer

#set(CMAKE_CXX_STANDARD 11)
#set(CMAKE_CXX_STANDARD_REQUIRED ON)

# For this package set as C++14
include(CheckCXXCompilerFlag)
CHECK_CXX_COMPILER_FLAG("-std=c++14" COMPILER_SUPPORTS_CXX14)
CHECK_CXX_COMPILER_FLAG("-std=c++0x" COMPILER_SUPPORTS_CXX0X)
if(COMPILER_SUPPORTS_CXX14)
    set(CMAKE_CXX_FLAGS "-std=c++14")
elseif(COMPILER_SUPPORTS_CXX0X)
    set(CMAKE_CXX_FLAGS "-std=c++0x")
else()
    message(FATAL_ERROR "The compiler ${CMAKE_CXX_COMPILER} has no C++14 support. Please use a different C++ compiler.")
endif()

###############################################################################
# Other dependencies...

find_package(catkin REQUIRED COMPONENTS gazebo_ros)
find_package(gazebo REQUIRED)
find_package(Eigen3 REQUIRED)

############################################################################### 
# Catkin...

catkin_package(
  INCLUDE_DIRS
    include
  LIBRARIES
    Hydrodynamics
    WavefieldModelPlugin
    WavefieldVisualPlugin
    wavegauge_plugin
  DEPENDS
    gazebo_ros
)

include_directories(
  ${PROJECT_SOURCE_DIR}/include
  ${Boost_INCLUDE_DIRS}
  ${catkin_INCLUDE_DIRS}
  ${EIGEN3_INCLUDE_DIR}
  ${GAZEBO_INCLUDE_DIRS}
  ${GAZEBO_MSG_INCLUDE_DIRS}
  ${IGNITION-COMMON_INCLUDE_DIRS}
  ${IGNITION-MATHS_INCLUDE_DIRS}
  ${IGNITION-MSGS_INCLUDE_DIRS}
  )

link_directories(
  ${GAZEBO_LIBRARY_DIRS}
  ${IGNITION-COMMON_LIBRARY_DIRS}
  ${IGNITION-MATHS_LIBRARY_DIRS}
  ${IGNITION-MSGS_LIBRARY_DIRS}
  )

############################################################################### 
# Libraries...

# Hydrodynamics
add_library(Hydrodynamics
  SHARED
    src/Gazebo.cc
    src/Geometry.cc
    src/PhysicalConstants.cc
    src/Physics.cc
    src/Utilities.cc
    src/Wavefield.cc
    src/WavefieldEntity.cc
)

target_link_libraries(Hydrodynamics
  ${Boost_LIBRARIES}
  ${catkin_LIBRARIES}
  ${GAZEBO_LIBRARIES}
)

target_compile_options(Hydrodynamics PRIVATE "-Wno-unknown-pragmas")

list(APPEND WAVE_GAZEBO_LIBRARIES_LIST Hydrodynamics)

############################################################################### 
# Plugins...

# WavefieldModelPlugin
add_library(WavefieldModelPlugin
  SHARED
    src/WavefieldModelPlugin.cc
)

target_link_libraries(WavefieldModelPlugin
  ${Boost_LIBRARIES}
  ${catkin_LIBRARIES}
  ${GAZEBO_LIBRARIES}
  ${WAVE_GAZEBO_LIBRARIES_LIST}
)

target_compile_options(WavefieldModelPlugin PRIVATE "-Wno-unknown-pragmas")

list(APPEND WAVE_GAZEBO_PLUGINS_LIST WavefieldModelPlugin)

# WavefieldVisualPlugin
add_library(WavefieldVisualPlugin
  SHARED
    src/WavefieldVisualPlugin.cc
)

target_link_libraries(WavefieldVisualPlugin
  ${Boost_LIBRARIES}
  ${catkin_LIBRARIES}
  ${GAZEBO_LIBRARIES}
  ${WAVE_GAZEBO_LIBRARIES_LIST}
)

target_compile_options(WavefieldVisualPlugin PRIVATE "-Wno-unknown-pragmas")

list(APPEND WAVE_GAZEBO_PLUGINS_LIST WavefieldVisualPlugin)


# WavegaugePlugin
add_library(wavegauge_plugin
  SHARED
    src/wavegauge_plugin.cc
)

target_link_libraries(wavegauge_plugin
  ${Boost_LIBRARIES}
  ${catkin_LIBRARIES}
  ${GAZEBO_LIBRARIES}
  ${WAVE_GAZEBO_LIBRARIES_LIST}
)

target_compile_options(wavegauge_plugin PRIVATE "-Wno-unknown-pragmas")

list(APPEND WAVE_GAZEBO_PLUGINS_LIST wavegauge_plugin)

############################################################################### 
# Executables...


############################################################################### 
# Tests...
# 
# Useful notes on running catkin tests:
# http://www.personalrobotics.ri.cmu.edu/software/unit-testing
# 

if(CATKIN_ENABLE_TESTING)

  catkin_add_gtest(UNIT_Wavefield_TEST src/Wavefield_TEST.cc)
  target_link_libraries(UNIT_Wavefield_TEST ${WAVE_GAZEBO_LIBRARIES_LIST})
  target_compile_options(UNIT_Wavefield_TEST PRIVATE "-Wno-unknown-pragmas")

endif()

############################################################################### 
# Install

install(TARGETS ${WAVE_GAZEBO_LIBRARIES_LIST}
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

install(TARGETS ${WAVE_GAZEBO_PLUGINS_LIST}
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

install(TARGETS ${WAVE_GAZEBO_EXECUTABLES_LIST}
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
  FILES_MATCHING PATTERN "*.hh"
  PATTERN "*~" EXCLUDE
)

install(DIRECTORY include/
   DESTINATION ${CATKIN_GLOBAL_INCLUDE_DESTINATION}
   FILES_MATCHING PATTERN ".hh"
)

install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
  FILES_MATCHING PATTERN "*.pb.*"
  PATTERN "*~" EXCLUDE
)

=== debian/changelog ===
ros-kinetic-wave-gazebo-plugins (1.3.0-1xenial) xenial; urgency=high



 -- Rhys Mainwaring <rhys.mainwaring@me.com>  Wed, 25 Dec 2019 23:00:00 -0000

ros-kinetic-wave-gazebo-plugins (1.2.6-1xenial) xenial; urgency=high



 -- Rhys Mainwaring <rhys.mainwaring@me.com>  Thu, 03 Oct 2019 22:00:00 -0000

ros-kinetic-wave-gazebo-plugins (1.2.5-1xenial) xenial; urgency=high

  * typo
  * Fix aspect ration with reflections.
  * Style.
  * apply reflection / refraction only to camera sensors
  * syntax tweak
  * removing redundancy in variable initialization
  * merging default into branch
  * Merged in maintenance (pull request #174)
    Minor maintenance updates
    Approved-by: Brian Bingham <mailto:briansbingham@gmail.com>
  * Changes for code checker
  * Contributors: Brian Bingham <mailto:briansbingham@gmail.com>, Carlos Aguero, Carlos Agüero <mailto:cen.aguero@gmail.com>, Ian Chen <mailto:ichen@osrfoundation.org>

 -- Rhys Mainwaring <rhys.mainwaring@me.com>  Wed, 18 Sep 2019 22:00:00 -0000

ros-kinetic-wave-gazebo-plugins (1.2.4-1xenial) xenial; urgency=high



 -- Rhys Mainwaring <rhys.mainwaring@me.com>  Wed, 11 Sep 2019 22:00:00 -0000

ros-kinetic-wave-gazebo-plugins (1.2.3-1xenial) xenial; urgency=high

  * Replace EnableVisualizations() with UserCameraCount().
  * Minor maintenance updates.
  * Contributors: Carlos Aguero

 -- Rhys Mainwaring <rhys.mainwaring@me.com>  Wed, 11 Sep 2019 22:00:00 -0000

ros-kinetic-wave-gazebo-plugins (1.2.2-1xenial) xenial; urgency=high

  * Combine boolean expressions.
  * Make code compatible with older Gazebo minor versions.
  * Contributors: Carlos Aguero

 -- Rhys Mainwaring <rhys.mainwaring@me.com>  Thu, 05 Sep 2019 22:00:00 -0000

ros-kinetic-wave-gazebo-plugins (1.2.1-1xenial) xenial; urgency=high

  * remove gazebo version check, scene blend
  * Add rttNoise parameter to scale distortion in refraction
  * Switch ratio->opacity naming
  * Clean code for checking GZ version
  * Test having higher required GZ major and minor version, but fix codecheck issues
  * Test having higher required GZ major and minor version
  * Fix build issues and document enableRtt
  * Use #if to not use ConnectCameraPreRender in gz7
  * Add enableRtt bool, may need to change as it likely still not build for gz7
  * Refactor to have more functions for clarity and to setup for optional no rtt
  * Clean code
  * Simplify code by removing unused private variables
  * Simplify NewCameras() by not using SensorManager
  * Fix code to pass code check
  * Clean up code with comments and removing redundant parts
  * Merged in Issue#122-Ocean-Reflections_ian (pull request #170)
    test using render events
  * Fix clipPlane position, need to use WorldPose()
  * test using render events
  * Fix to build on gz7
  * Change clipPlane updates to build on gz7
  * Update comments
  * Add more clarity with comments
  * Update header file for better comments and less redundancy
  * Remove redundant cameras.size() == 0 check
  * Set ocean texture only in preRenderTargetUpdate(), not postRenderTargetUpdate()
  * Remove writing texture contents to file for debugging
  * Add better comments, clean out redundant code, pass code check
  * Move flipAcrossY to setupreflrefr() to be just set once
  * Move flipAcrossY setup from preRender to Load for efficiency
  * Add flipAcrossY temp fix for camera sensors
  * Increase reflection for easier debugging, rm redundant code, writeContentsToFile
  * Add listener for user camera correctly with OgreViewport
  * Try to run addListener for usercams and camera sensors, usercam texture returning null
  * Add Ian's recommended change, image_viewer still not show refl
  * Make ocean reflections work, even if ocean pose changes (position and angle)
  * Fix codecheck build errors
  * Save textures to pngs for viewing
  * Store reflect/refract texture unit states for easier usage
  * Iterate through all rts in preRenderTargetUpdate() and postRenderTargetUpdate(), client working, but sensors not
  * IMPORTANT FIX: remove unneeded pause variable that was never set or cleared, causing issues with updating
  * Update OnRender to update all textures
  * In client, add usercam. In server, add all sensors. Still working, but not camera sensors
  * Remove redundant comments, still leave in variables to runs fine now, but not sure why they are needed
  * Very strange, comment out these unused variables and it sometimes doesn't work (waves don't move)
  * Fully functional, but if I comment out the Ogre objects, it stops working sometimes
  * Transition to using vectors, but not fully. Fully functional
  * Refactor to get ready for transition, fully functional tested multiple times, about to switch to vectors
  * After fixing multiple head issues, stable working commit of user camera reflections
  * Set correct visibility to see proper wave movement and add prints
  * Use vector of cams, rtts, textures. Runs, shows reflections for user cam, but not for sensors.
  * Reintegration to make refl/refr still work
  * Add CreateReflRefrTexture function to work on rendering::Camera, need to finish integration
  * Reorder SetupReflRefr function to only do one-time assignments, so that CreateReflRefrTexture function can be added
  * Create NewCameras() function, working but need to add Usercams and cams as well
  * Add new cameras from OnPreRender()
  * Change render order of water to properly render propellers
  * Add documentation to header file
  * Fix build issues
  * Define refl/refr amounts in model.xacro, then use visual plugin to set the parameters
  * Fix build issues related to gz7 by storing visual name
  * Add comments, clean code, pass code check
  * Reduce reflection and refraction amounts to make more subtle effect
  * Integrate reflection with Gerstner waves, working well
  * Show updated render picture
  * Change mesh->plane and show pure reflection color on it, working well but need to switch back to mesh


=== debian/control ===
Source: ros-kinetic-wave-gazebo-plugins
Section: misc
Priority: optional
Maintainer: Rhys Mainwaring <rhys.mainwaring@me.com>
Build-Depends: debhelper (>= 9.0.0), libeigen3-dev, ros-kinetic-catkin, ros-kinetic-gazebo-ros
Homepage: 
Standards-Version: 3.9.2

Package: ros-kinetic-wave-gazebo-plugins
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-kinetic-gazebo-ros
Description: This package contains Gazebo plugins for the simulation of water surface waves and hydrostatic and hydrodynamics forces.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/kinetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/kinetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/kinetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-kinetic-wave-gazebo-plugins//opt/ros/kinetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_install
